import { PublicKey } from "@solana/web3.js";
import { PROGRAM_ID } from "./constants";
import * as anchor from "@coral-xyz/anchor";
export function bridgeKey(rndrMint, wrndrMint, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("bridge", "utf-8"),
        rndrMint.toBuffer(),
        wrndrMint.toBuffer()
    ], programId);
}
export function transferKey(vaaMsg, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("transfer", "utf-8"),
        vaaMsg
    ], programId);
}
export function upgradePointsKey(recipient, epochId, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("upgrade_points", "utf-8"),
        recipient.toBuffer(),
        new anchor.BN(epochId).toBuffer("le", 8)
    ], programId);
}
export function totalUpgradePointsKey(epochId, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("total_upgrade_points", "utf-8"),
        new anchor.BN(epochId).toBuffer("le", 8)
    ], programId);
}
export function foreignContractKey(chain, programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("foreign_contract"),
        (() => {
            const buf = Buffer.alloc(2);
            buf.writeUInt16LE(chain);
            return buf;
        })(),
    ], programId);
}
export function redeemerConfigKey(programId = PROGRAM_ID) {
    return PublicKey.findProgramAddressSync([
        Buffer.from("redeemer"),
    ], programId);
}
//# sourceMappingURL=pdas.js.map